unit KampId3Tag;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  ID3v11Tag = record
    Tag: array[0..2] of Char;
    Songname: array[0..29] of Char;
    Artist: array[0..29] of Char;
    Album: array[0..29] of Char;
    Year: array[0..3] of Char;
    Comment: array[0..29] of Char;
    Genre: Byte;
  end;

type
  TForm2 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    ComboBox1: TComboBox;
    GreatGfX: TImage;
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    Mp3filename: string;
  public
    function ReadID3Tag(FileName: string): ID3v11Tag;
    function WriteID3Tag(FileName: string; ID3Tag: ID3v11Tag): Boolean;
    function RemoveID3Tag(FileName: string): Boolean;
    procedure DisplayID3Tag(ID3Tag: ID3v11Tag);
    function ID3TagsAreEqual(ID3Tag1, ID3Tag2: ID3v11Tag): Boolean;
    { Public declarations }
  end;

const
  ID3Genres: array[0..125] of string = (
    'Blues', 'Classic Rock', 'Country', 'Dance', 'Disco', 'Funk',
    'Grunge', 'Hip-Hop', 'Jazz', 'Metal', 'New Age', 'Oldies', 'Other',
    'Pop', 'R&B', 'Rap', 'Reggae', 'Rock', 'Techno', 'Industrial',
    'Alternative', 'Ska', 'Death Metal ', 'Pranks', 'Soundtrack ',
    'Euro - Techno', 'Ambient', 'Trip - Hop', 'Vocal', 'Jazz & Funk',
    'Fusion', 'Trance', 'Classical', 'Instrumental', 'Acid', 'House',
    'Game', 'Sound Clip', 'Gospel', 'Noise', 'Alternative-Rock', 'Bass',
    'Soul', 'Punk', 'Space', 'Meditative', 'Instrumental Pop',
    'Instrumental Rock', 'Ethnic', 'Gothic', 'Darkwave', 'Techno-Industrial',
    'Electronic', 'Pop-Folk', 'Eurodance', 'Dream', 'Southern Rock',
    'Comedy', 'Cult', 'Gangsta', 'Top 40', 'Christian Rap', 'Pop/Funk',
    'Jungle', 'Native American', 'Cabaret', 'New Wave', 'Psychedelic',
    'Rave', 'Show Tunes', 'Trailer', 'Lo-Fi', 'Tribal', 'Acid Punk ',
    'Acid Jazz ', 'Polka', 'Retro', 'Musical', 'Rock & Roll',
    'Hard Rock', 'Folk', 'Folk-Rock', 'National Folk', 'Swing',
    'Fast Fusion', 'Bebop', 'Latin', 'Revival', 'Celtic', 'Bluegrass',
    'Avant-garde', 'Gothic Rock', 'Progressive Rock', 'Psychedelic Rock',
    'Symphonic Rock', 'Slow Rock', 'Big Band', 'Chorus', 'Easy Listening',
    'Acoustic', 'Humour', 'Speech', 'Chanson', 'Opera', 'Chamber Music',
    'Sonata', 'Symphony', 'Booty Bass', 'Primus', 'Porn Groove',
    'Satire', 'Slow Jam', 'Club', 'Tango', 'Samba', 'Folklore', 'Ballad',
    'Power Ballad', 'Rhythmic Soul', 'Freestyle', 'Duet', 'Punk Rock',
    'Drum Solo', 'Acapella', 'Euro-House', 'Dance Hall');

procedure ArrayToStrings(theArray: array of string; var theStrings: TStrings);

var
  Form2: TForm2;
  ID3Tag: ID3v11Tag;

implementation

uses KampMain;

{$R *.DFM}

procedure TForm2.FormShow(Sender: TObject);
var
  GenreItems: TStringlist;
begin
  GenreItems := TStringlist.create;
  arraytostrings(ID3Genres, TStrings(GenreItems));
  combobox1.items := GenreItems;
  GenreItems.free;
  //must change temp change the streamName to enable file i/o access
  Mp3filename := Kampx1.MPlayer.StreamName;
  Kampx1.MPlayer.StreamName := '';

  ID3Tag := ReadID3Tag(MP3filename);
  DisplayID3Tag(ID3Tag);
end;


procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Kampx1.MPlayer.StreamName := MP3filename;
end;


function TForm2.ReadID3Tag(FileName: string): ID3v11Tag;
var
  F: file;
begin
{$I-}
  AssignFile(F, FileName);
  Reset(F, 1);
  Seek(F, Filesize(F) - SizeOf(ID3v11Tag));
  Result.Tag[1] := 'N';
  BlockRead(F, Result, SizeOf(ID3v11Tag));
  CloseFile(F);
{$I+}
end;


function TForm2.WriteID3Tag(FileName: string; ID3Tag: ID3v11Tag): Boolean;
var
  F: file;
  X: Integer;
begin
{$I-}
  AssignFile(F, FileName);
  Reset(F, 1);
  if ReadID3Tag(FileName).Tag <> 'TAG' then Seek(F, FileSize(F))
  else Seek(F, FileSize(F) - SizeOf(ID3v11Tag));
  BlockWrite(F, ID3Tag, SizeOf(ID3v11Tag), X);
  Result := (X <> 0);
  CloseFile(F);
{$I+}
end;

function TForm2.RemoveID3Tag(FileName: string): Boolean;
var
  FileHandle: integer;
begin
{$I-}
  FileHandle := FileOpen(FileName, fmOpenReadWrite or fmShareDenyWrite);
  if FileHandle > 0 then
      if ID3Tag.Tag = 'TAG' then
        begin
          FileSeek(FileHandle, 0 - SizeOf(ID3v11Tag), 2);
          SetEndOfFile(FileHandle);
        end;
   FileClose(FileHandle);
   result := FileHandle <> 0;
{$I+}
end;

procedure TForm2.DisplayID3Tag(ID3Tag: ID3v11Tag);

var
  Msg: string;
begin
  if ID3Tag.Tag <> 'TAG' then
    begin
      fillchar(ID3Tag, sizeof(ID3Tag), #0);
      ID3Tag.Genre := 255;
    end;
  with ID3Tag do
    begin
      Edit1.text := trim(string(MP3filename));
      Edit2.text := trim(string(Songname));
      Edit3.text := trim(string(Artist));
      Edit4.text := trim(string(Album));
      Edit5.text := trim(string(Year));
      Edit6.text := trim(string(Comment));
      combobox1.text := trim(ID3Genres[Genre]);
    end;
end;

function TForm2.ID3TagsAreEqual(ID3Tag1, ID3Tag2: ID3v11Tag): Boolean;
begin
  with ID3Tag1 do
    if (string(ID3Tag2.Tag) <> string(Tag)) or
      (string(ID3Tag2.Songname) <> string(SongName)) or
      (string(ID3Tag2.Artist) <> string(Artist)) or
      (string(ID3Tag2.Album) <> string(Album)) or
      (string(ID3Tag2.Year) <> string(Year)) or
      (string(ID3Tag2.Comment) <> string(Comment)) or
      (ID3Tag2.Genre <> Genre) then Result := False
    else Result := True;
end;

procedure TForm2.Button2Click(Sender: TObject);
var
  S: string;
  GenreItems: TStringlist;
begin
  case (sender as TButton).tag of
    1:
      begin
        with ID3Tag do
          begin
            Tag := 'TAG';
            S := edit2.text;
            if length(S) > 30 then setlength(S, 30);
            StrPCopy(Songname, S);
            S := edit3.text;
            if length(S) > 30 then setlength(S, 30);
            StrPCopy(Artist, S);
            S := edit4.text;
            if length(S) > 30 then setlength(S, 30);
            StrPCopy(Album, S);
            S := edit5.text;
            if length(S) > 4 then setlength(S, 4);
            StrPCopy(Year, Edit5.text);
            S := edit6.text;
            if length(S) > 30 then setlength(S, 30);
            StrPCopy(Comment, Edit6.text);

            GenreItems := TStringlist.create;
            arraytostrings(ID3Genres, TStrings(GenreItems));
            Genre := GenreItems.IndexOf(combobox1.items[combobox1.itemindex]);
            GenreItems.free;
          end;
        if not WriteID3Tag(MP3FileName, ID3Tag) then
          MessageDlg('Unknown Error.  Cannot write ID3 Tag to file.', mtError, [mbOK], 0);
      end;
    3: RemoveID3Tag(MP3FileName);
  end;
  close;
end;

procedure ArrayToStrings(theArray: array of string; var theStrings: TStrings);
var
  x, i: integer;
begin
  x := sizeof(theArray) div sizeof(string);
  for i := 0 to x - 1 do
    theStrings.append(theArray[i]);
end;



end.

