unit KampMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, Buttons, MPEGPlay, ExtCtrls, ComCtrls, slider, Banner, TransBtn,
  Scope2, VUMeter, Menus, KTop, TrayIcon, NoTask, fm;

type
  TKampx1 = class(TForm)
    MPlayer: TMPEGPlayer;
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    RxSlider1: TSlider;
    TimeLabel: TLabel;
    LayerLabel: TLabel;
    kbpslabel: TLabel;
    kHzlabel: TLabel;
    ID3TXT: TBanner;
    TrueTime: TLabel;
    LabelHint: TLabel;
    AboutKampBtn: TTransparentButton;
    VUTime: TTimer;
    Vumeter1: TVumeter;
    BarR: Tindicator2;
    BarL: Tindicator2;
    TasKYepOrNoP: TNoTask;
    SysTrayIcon: TTrayIcon;
    KTop1: TKTop;
    POPMENUP: TPopupMenu;
    KAmP1: TMenuItem;
    N5: TMenuItem;
    GetMeOutOfHere1: TMenuItem;
    Dreamer: TTransparentButton;
    Minimize: TTransparentButton;
    TOPNOTTOP: TTransparentButton;
    PlayBtn1: TTransparentButton;
    PauseBtn1: TTransparentButton;
    StopBtn: TTransparentButton;
    Button1: TTransparentButton;
    OpenBtn: TTransparentButton;
    KAmPID3TagEditor1: TMenuItem;
    N1: TMenuItem;
    PlayBack1: TMenuItem;
    Play1: TMenuItem;
    Previous1: TMenuItem;
    Pause1: TMenuItem;
    Stop1: TMenuItem;
    Next1: TMenuItem;
    TheGfXSuberb: TImage;
    FormShaper1: TFormShaper;
    procedure PlayBtn1Click(Sender: TObject);
    procedure PauseBtn1Click(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RxSlider1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MPlayerPosUpdate(Pos, Len: LongInt);
    procedure MPlayerPlayEnd(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TimeLabelClick(Sender: TObject);
    procedure AboutKampBtnClick(Sender: TObject);
    procedure VUTimeTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DreamerClick(Sender: TObject);
    procedure TOPNOTTOPClick(Sender: TObject);
    procedure MinimizeClick(Sender: TObject);
    procedure SysTrayIconClick(Sender: TObject);
    procedure GetMeOutOfHere1Click(Sender: TObject);
    procedure KAmP1Click(Sender: TObject);
    procedure KAmPID3TagEditor1Click(Sender: TObject);
  private
    procedure DoOpen;
  public
    Dontseek : boolean; {means that slider has to be updated}
    procedure ShowHint(Sender: TObject); //show the hint in the label
    procedure CallBackCreateStream (var cant_seek:boolean; var res:pointer);
    procedure CallBackCloseStream (handle :pointer);
    procedure CallBackRestartStream (handle :pointer; var res:boolean);
    procedure CallBackReadStream (handle:pointer;
                   var read_buffer;
                   nNumberOfBytesToRead:longint;
                   var nNumberOfBytesRead:longInt; var res:boolean);
     procedure CallBackSeekStream (handle:pointer;
                        NumBytes,MoveMethod:LongInt; var res:LongInt);
     procedure CallBackGetStreamSize (handle:pointer; var res:longint);
  end;

function msToMinSec(t: integer): string;

Type TTimeFormat = (tfTimeEllapsed, tfTimeLeft);

var
  Kampx1: TKampx1;
  TimeFormat : TTimeFormat;

implementation

uses KampId3Tag, Unit2;

{$R *.DFM}

procedure TKampx1.CallBackCreateStream;
var t:TFileStream;
begin
  t:=TFileStream.Create(MPlayer.StreamName, fmOpenRead or fmShareExclusive);
  res:=pointer(t);
  Cant_seek:=false;
end;

procedure TKampx1.CallBackCloseStream;
begin
  TFileStream(handle).free;
end;

procedure TKampx1.CallBackRestartStream;
begin
  res:=((TFileStream(handle).Seek(0,soFromBeginning))=0);
end;

procedure TKampx1.CallBackReadStream;
begin
  nNumberOfBytesRead:=TFileStream(handle).Read(read_buffer, nNumberOfBytesToRead);
  res:=true;
end;

procedure TKampx1.CallBackSeekStream;
begin
  res:=(TFileStream(handle).Seek(NumBytes,MoveMethod));
end;

procedure TKampx1.CallBackGetStreamSize;
begin
  res:=TFileStream(handle).Size;
end;
{The Play Button}
procedure TKampx1.PlayBtn1Click(Sender: TObject);
begin
  if MPlayer.paused then
  begin
    MPlayer.Paused:=false;
    PlayBtn1.Enabled:=false;
    Pausebtn1.Enabled:=true;
  end
  else
  begin
    MPlayer.Play;
    PlayBtn1.Enabled:=false;
    StopBtn.Enabled:=true;
    Pausebtn1.Enabled:=true;
    button1.enabled := false;
    KAmPID3TagEditor1.enabled := false;
  end;
end;
{The Pause Button}
procedure TKampx1.PauseBtn1Click(Sender: TObject);
begin
  MPlayer.paused:=not (Mplayer.Paused);
  Pausebtn1.Enabled:=not (MPlayer.Paused);
  PlayBtn1.Enabled:=MPlayer.Paused;
end;
{The Stop Button}
procedure TKampx1.StopBtnClick(Sender: TObject);
begin
  RXSlider1.Value:=0;
  StopBtn.Enabled:=false;
  Pausebtn1.Enabled:=false;
  PlayBtn1.Enabled:=true;
  button1.enabled := true;
  KAmPID3TagEditor1.enabled := true;
  MPlayer.Close;
end;

procedure TKampx1.DoOpen;
var s:string;
begin
  MPlayer.Open;
  RxSlider1.MaxValue:=MPlayer.Length;
  RXSlider1.Value:=0;
  Str(RxSlider1.MaxValue, s);
//  LengthLabel.Caption:=s;
  PlayBtn1.Enabled:=true;
  StopBtn.Enabled:=false;
  Pausebtn1.Enabled:=false;
end;
{The Open Button}
procedure TKampx1.OpenBtnClick(Sender: TObject);
begin
  if not OpenDialog1.Execute then exit;
  ID3Tag := Form2.ReadID3Tag(OpenDialog1.FileName);

  MPlayer.StreamName:=OpenDialog1.FileName;
  DoOpen;

  if (ID3Tag.Tag = 'TAG') and (trim(ID3Tag.songname) <> '')
    then ID3TXT.ScrollText := ' | ' + Trim(ID3Tag.songname)    //Display the Songname etc.. in the Label
                           + ' / ' + Trim(ID3Tag.Artist)
                           + ' / ' + Trim(ID3Tag.Album)
                           + ' / ' + Trim(ID3Tag.Year)
                           + ' / ' + Trim(ID3Tag.Comment) + ' | '
                           + ' (' + msToMinSec(MPlayer.Length) + ')'
  else ID3TXT.ScrollText := ExtractFileName(MPlayer.StreamName)
                         + ' (' + msToMinSec(MPlayer.Length) + ')';
  LayerLabel.Caption := 'Layer ' + IntToStr(Mplayer.layer);
  kbpslabel.caption := IntToStr(Mplayer.bitrate div 1000) + ' kbps';
  kHzlabel.caption := IntToStr(Mplayer.frequency div 1000) + ' kHz';
  truetime.caption := ' (' + msToMinSec(MPlayer.Length) + ')';
end;


procedure TKampx1.ShowHint(Sender: TObject);
begin
     LabelHint.caption := Application.Hint;
end;


procedure TKampx1.FormCreate(Sender: TObject);
begin
  MPlayer.init;
  MPlayer.OnOpenStream:=CallBackCreateStream;
  MPlayer.OnCloseStream:=CallBackCloseStream;
  MPlayer.OnRestartStream:=CallBackRestartStream;
  MPlayer.OnGetStreamSize:=CallBackGetStreamSize;
  MPlayer.OnSeekStream:=CallBackSeekStream;
  MPlayer.OnReadStream:=CallBackReadStream;
  TimeFormat := tfTimeEllapsed;
  Application.OnHint    := ShowHint;

  end;

procedure TKampx1.Timer1Timer(Sender: TObject);
begin
  if not MPlayer.DLLLoaded then exit;
  if (MPlayer.mode=plmPlaying) then
  begin
    DontSeek:=true;
    RXSlider1.Value:=MPlayer.CurrentPosition;
    DontSeek:=false;
  end;
  if MPlayer.PlayStopped then
  begin
    RXSlider1.Value:=0;
    PlayBtn1.Enabled:=true;
    StopBtn.Enabled:=false;
    Pausebtn1.Enabled:=false;
    if K_AmP_About.LoopedCB.checked then
    begin
      MPlayer.Restart;
      PlayBtn1.Enabled:=false;
      StopBtn.Enabled:=true;
      Pausebtn1.Enabled:=true;
    end;
  end;
end;

procedure TKampx1.RxSlider1Change(Sender: TObject);
begin
  if not (DontSeek) then
    if (MPlayer.mode=plmPlaying) or ((MPlayer.mode=plmPaused))
      then MPlayer.CurrentPosition:=RXSlider1.Value;
end;

{Display the Time in the Time Label}
procedure TKampx1.TimeLabelClick(Sender: TObject);
begin
  if TimeFormat = tfTimeEllapsed then TimeFormat := tfTimeLeft
  else TimeFormat := tfTimeEllapsed;
end;
{Close Mplayer}
procedure TKampx1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MPlayer.Deinit;
end;
{Update the Mplayr position}
procedure TKampx1.MPlayerPosUpdate(Pos, Len: Integer);
var
  t: integer;
begin
  DontSeek:=true;
  t := MPlayer.CurrentPosition;
  if t > mplayer.length then t :=0;  //to avoid flickering at start

  RXSlider1.Value:= t;
  if TimeFormat = tfTimeEllapsed then
    TimeLabel.caption := msToMinSec(t)
  else
    TimeLabel.caption := '-' + msToMinSec(Mplayer.length - t);
  DontSeek:=false;
end;

procedure TKampx1.MPlayerPlayEnd(Sender: TObject);
begin
  RXSlider1.Value:=0;
  PlayBtn1.Enabled:=true;
  StopBtn.Enabled:=false;
  Pausebtn1.Enabled:=false;
  if K_AmP_About.LoopedCB.checked then
  begin
    MPlayer.Restart;
    PlayBtn1.Enabled:=false;
    StopBtn.Enabled:=true;
    Pausebtn1.Enabled:=true;
  end;
end;


procedure TKampx1.Button2Click(Sender: TObject);
begin
close;
end;


procedure TKampx1.Button1Click(Sender: TObject);
begin
     form2.showmodal;
end;

function msToMinSec(t: integer): string;
var
  min, sec : integer;
  s1,s2: string;
begin
  sec := t div 1000;
  min := sec div 60;
  sec := (sec - min * 60);
  if min >9 then s1 := intToStr(min)
  else s1 := '0' + intToStr(min);
  if sec >9 then s2 := intToStr(sec)
  else s2 := '0' + intToStr(sec);
  result := S1 + ':' + S2;
end;





procedure TKampx1.AboutKampBtnClick(Sender: TObject);
begin
     K_AmP_About.showmodal;
end;


procedure TKampx1.VUTimeTimer(Sender: TObject);
begin
if Vumeter1.Update then
  begin
    BarL.Position := vumeter1.leftpeak;
    BarR.Position := vumeter1.RightPeak;
   end;

end;


procedure TKampx1.FormActivate(Sender: TObject);
begin
Vumeter1.Start;
end;


procedure TKampx1.DreamerClick(Sender: TObject);
begin
Close;
end;

procedure TKampx1.TOPNOTTOPClick(Sender: TObject);
begin
     Ktop1.Ktop := not Ktop1.Ktop;
end;

procedure TKampx1.MinimizeClick(Sender: TObject);
begin
  SysTrayIcon.HideMainForm;
  SysTrayIcon.IconVisible := true;
end;

procedure TKampx1.SysTrayIconClick(Sender: TObject);
begin
  SysTrayIcon.ShowMainForm;
end;

procedure TKampx1.GetMeOutOfHere1Click(Sender: TObject);
begin
     Close;
end;

procedure TKampx1.KAmP1Click(Sender: TObject);
begin
     K_AmP_About.showmodal;
end;


procedure TKampx1.KAmPID3TagEditor1Click(Sender: TObject);
begin
     form2.showmodal;
end;

initialization
 fillchar(ID3Tag, sizeof(ID3Tag), #0);
 ID3Tag.Genre := 255;


end.


